## modules 4.3.1

=== Makefile ===
.PHONY: doc pkgdoc initdir install install-testsiteconfig \
	install-testsiteconfig-1 install-testmodulerc install-testmodulerc-1 \
	install-testinitrc install-testetcrc install-testmodspath \
	install-testmodspath-empty uninstall-testconfig uninstall dist dist-tar \
	dist-gzip dist-bzip2 srpm clean distclean test testinstall testsyntax

# definitions for code coverage
NAGELFAR_DLSRC1 := http://downloads.sourceforge.net/nagelfar/
NAGELFAR_DLSRC2 := https://ftp.openbsd.org/pub/OpenBSD/distfiles/
NAGELFAR_RELEASE := nagelfar125
NAGELFAR_DIST := $(NAGELFAR_RELEASE).tar.gz
NAGELFAR_DISTSUM := 707e3c305437dce1f14103f0bd058fc9
NAGELFAR := $(NAGELFAR_RELEASE)/nagelfar.tcl

# definition for old Tcl interpreter for coverage testing
TCL_DLSRC := http://downloads.sourceforge.net/tcl/
TCL_RELEASE83 := tcl8.3.5
TCL_DIST83 := $(TCL_RELEASE83)-src.tar.gz
TCL_DISTSUM83 := 5cb79f8b90cf1322cb1286b9fe67f7a2
TCLSH83 := $(TCL_RELEASE83)/unix/tclsh

# specific modulecmd script for test
MODULECMDTEST := modulecmd-test.tcl

# definitions for enhanced diff tool (to review test results)
ICDIFF_DLSRC := https://raw.githubusercontent.com/jeffkaufman/icdiff/release-1.9.2/
ICDIFF_CHECKSUM := 2bf052d9dfb0a46af581fc390c47774a

# compatibility version-related files
COMPAT_DIR := compat

# source definitions shared across the Makefiles of this project
ifneq ($(wildcard Makefile.inc),Makefile.inc)
  $(error Makefile.inc is missing, please run './configure')
endif
include Makefile.inc

INSTALL_PREREQ := modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
	contrib/scripts/modulecmd
TEST_PREREQ := $(MODULECMDTEST)

ifeq ($(compatversion),y)
INSTALL_PREREQ += $(COMPAT_DIR)/modulecmd$(EXEEXT) $(COMPAT_DIR)/ChangeLog
ifeq ($(wildcard $(COMPAT_DIR)),$(COMPAT_DIR))
TEST_PREREQ += $(COMPAT_DIR)/modulecmd
endif
endif

ifeq ($(libtclenvmodules),y)
INSTALL_PREREQ += lib/libtclenvmodules$(SHLIB_SUFFIX)
TEST_PREREQ += lib/libtclenvmodules$(SHLIB_SUFFIX)
ifeq ($(COVERAGE),y)
TEST_PREREQ += lib/libtestutil-closedir$(SHLIB_SUFFIX)
endif
endif

ifeq ($(COVERAGE),y)
TEST_PREREQ += $(NAGELFAR)
endif

# install old Tcl interpreters to test coverage
ifeq ($(COVERAGE_OLDTCL),y)
TEST_PREREQ += tclsh83
endif

all: initdir $(INSTALL_PREREQ)

# skip doc build if no sphinx-build
ifeq ($(builddoc),y)
all: pkgdoc
endif

initdir: version.inc
	$(MAKE) -C init all

pkgdoc: version.inc
	$(MAKE) -C doc man txt

doc: version.inc
	$(MAKE) -C doc all

# build version.inc shared definitions from git repository info
ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
GIT_CURRENT_TAG := $(shell git describe --tags --abbrev=0)
GIT_CURRENT_DESC := $(shell git describe --tags)
GIT_CURRENT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD)

MODULES_RELEASE := $(subst v,,$(GIT_CURRENT_TAG))
MODULES_BUILD_DATE := $(shell git log -1 --format=%cd --date=short)
ifeq ($(GIT_CURRENT_TAG),$(GIT_CURRENT_DESC))
MODULES_BUILD :=
else ifeq ($(GIT_CURRENT_BRANCH),master)
MODULES_BUILD := +$(subst $(GIT_CURRENT_TAG)-,,$(GIT_CURRENT_DESC))
else
MODULES_BUILD := +$(GIT_CURRENT_BRANCH)$(subst $(GIT_CURRENT_TAG),,$(GIT_CURRENT_DESC))
endif

# determine RPM release
# use last release if we currently sat on tag, append build number to it elsewhere
MODULES_LAST_RPM_VERSREL := $(shell sed -n '/^%changelog/ {n;s/^\*.* - //p;q;}' \
	contrib/rpm/environment-modules.spec.in)
MODULES_LAST_RPM_RELEASE := $(lastword $(subst -, ,$(MODULES_LAST_RPM_VERSREL)))
MODULES_RPM_RELEASE := $(MODULES_LAST_RPM_RELEASE)$(subst +,.,$(subst -,.,$(MODULES_BUILD)))

else
# source version definitions shared across the Makefiles of this project
ifneq ($(wildcard version.inc),version.inc)
  $(error version.inc is missing)
endif
include version.inc
endif

# define init configs location
ifeq ($(initconfin),etcdir)
  modulespath := $(etcdir)/modulespath
  initrc := $(etcdir)/initrc
else
  modulespath := $(initdir)/.modulespath
  initrc := $(initdir)/modulerc
endif

# comment entries if feature not enabled
ifeq ($(versioning),y)
  setversioning :=
  setnotversioning := \#
else
  setversioning := \#
  setnotversioning :=
endif

ifeq ($(silentshdbgsupport),y)
  setsilentshdbgsupport :=
else
  setsilentshdbgsupport := \#
endif

ifeq ($(quarantinesupport),y)
  setquarantinesupport :=
  setnotquarantinesupport := \#
else
  setquarantinesupport := \#
  setnotquarantinesupport :=
endif

ifeq ($(libtclenvmodules),y)
  setlibtclenvmodules :=
else
  setlibtclenvmodules := \#
endif

ifeq ($(color),y)
  setcolor := 1
else
  setcolor := 0
endif

ifeq ($(autohandling),y)
  setautohandling := 1
else
  setautohandling := 0
endif

ifeq ($(availindepth),y)
  setavailindepth := 1
else
  setavailindepth := 0
endif

ifeq ($(implicitdefault),y)
  setimplicitdefault := 1
else
  setimplicitdefault := 0
endif

ifeq ($(setshellstartup),y)
  setsetshellstartup := 1
else
  setsetshellstartup := 0
endif

ifeq ($(wa277),y)
  setwa277 := 1
else
  setwa277 := 0
endif

define translate-in-script
sed -e 's|@prefix@|$(prefix)|g' \
	-e 's|@baseprefix@|$(baseprefix)|g' \
	-e 's|@libdir@|$(libdir)|g' \
	-e 's|@libexecdir@|$(libexecdir)|g' \
	-e 's|@initdir@|$(initdir)|g' \
	-e 's|@etcdir@|$(etcdir)|g' \
	-e 's|@modulefilesdir@|$(modulefilesdir)|g' \
	-e 's|@VERSION@|$(VERSION)|g' \
	-e 's|@TCLSHDIR@/tclsh|$(TCLSH)|g' \
	-e 's|@TCLSH@|$(TCLSH)|g' \
	-e 's|@pager@|$(pager)|g' \
	-e 's|@pageropts@|$(pageropts)|g' \
	-e 's|@verbosity@|$(verbosity)|g' \
	-e 's|@color@|$(setcolor)|g' \
	-e 's|@darkbgcolors@|$(darkbgcolors)|g' \
	-e 's|@lightbgcolors@|$(lightbgcolors)|g' \
	-e 's|@termbg@|$(termbg)|g' \
	-e 's|@lockedconfigs@|$(lockedconfigs)|g' \
	-e 's|@unloadmatchorder@|$(unloadmatchorder)|g' \
	-e 's|@implicitdefault@|$(setimplicitdefault)|g' \
	-e 's|@searchmatch@|$(searchmatch)|g' \
	-e 's|@wa277@|$(setwa277)|g' \
	-e 's|@autohandling@|$(setautohandling)|g' \
	-e 's|@availindepth@|$(setavailindepth)|g' \
	-e 's|@silentshdbgsupport@|$(setsilentshdbgsupport)|g' \
	-e 's|@setshellstartup@|$(setsetshellstartup)|g' \
	-e 's|@quarantinesupport@|$(setquarantinesupport)|g' \
	-e 's|@notquarantinesupport@|$(setnotquarantinesupport)|g' \
	-e 's|@libtclenvmodules@|$(setlibtclenvmodules)|g' \
	-e 's|@SHLIB_SUFFIX@|$(SHLIB_SUFFIX)|g' \
	-e 's|@VERSIONING@|$(setversioning)|g' \
	-e 's|@NOTVERSIONING@|$(setnotversioning)|g' \
	-e 's|@MODULES_RELEASE@|$(MODULES_RELEASE)|g' \
	-e 's|@MODULES_BUILD@|$(MODULES_BUILD)|g' \
	-e 's|@MODULES_RPM_RELEASE@|$(MODULES_RPM_RELEASE)|g' \
	-e 's|@MODULES_BUILD_DATE@|$(MODULES_BUILD_DATE)|g' $< > $@
endef

ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
# rebuild if git repository changed
version.inc: version.inc.in .git/index
	$(translate-in-script)

contrib/rpm/environment-modules.spec: contrib/rpm/environment-modules.spec.in .git/index
	$(translate-in-script)

else
# avoid shared definitions to be rebuilt by make
version.inc: ;

# do not rebuild spec file if not in git repository
contrib/rpm/environment-modules.spec: ;
endif

DIST_PREFIX := modules-$(MODULES_RELEASE)$(MODULES_BUILD)

# avoid shared definitions to be rebuilt by make
Makefile.inc: ;

modulecmd.tcl: modulecmd.tcl.in version.inc
	$(translate-in-script)
	chmod +x $@

ChangeLog:
	contrib/gitlog2changelog.py

README:
	sed -e '/^\[\!\[.*\].*/d' $@.md > $@

contrib/mtreview: contrib/mtreview.in version.inc
	$(translate-in-script)
	chmod +x $@

contrib/mb: contrib/mb.in version.inc
	$(translate-in-script)
	chmod +x $@

contrib/scripts/add.modules: contrib/scripts/add.modules.in
	$(translate-in-script)

contrib/scripts/modulecmd: contrib/scripts/modulecmd.in
	$(translate-in-script)

# compatibility version-related rules
$(COMPAT_DIR)/modulecmd$(EXEEXT) $(COMPAT_DIR)/ChangeLog:
	$(MAKE) -C $(COMPAT_DIR) $(@F)

# Tcl extension library-related rules
lib/libtclenvmodules$(SHLIB_SUFFIX):
	$(MAKE) -C lib $(@F)

lib/libtestutil-closedir$(SHLIB_SUFFIX):
	$(MAKE) -C lib $(@F)

# example configs for test rules
testsuite/example/.modulespath: testsuite/example/.modulespath.in
	$(translate-in-script)

testsuite/example/modulerc: testsuite/example/modulerc.in
	$(translate-in-script)

testsuite/example/modulerc-1: testsuite/example/modulerc-1.in
	$(translate-in-script)

testsuite/example/initrc: testsuite/example/initrc.in
	$(translate-in-script)

install-testsiteconfig: testsuite/example/siteconfig.tcl
	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(etcdir)/

install-testsiteconfig-1: testsuite/example/siteconfig.tcl-1
	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(etcdir)/siteconfig.tcl

install-testmodulerc: testsuite/example/modulerc
	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(initrc)

install-testmodulerc-1: testsuite/example/modulerc-1
	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(initrc)

install-testinitrc: testsuite/example/initrc
	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(initrc)

install-testetcrc: testsuite/etc/empty
	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(etcdir)/rc

install-testmodspath: testsuite/example/.modulespath
	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(modulespath)

install-testmodspath-empty: testsuite/example/.modulespath-empty
	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(modulespath)

uninstall-testconfig:
	rm -f $(DESTDIR)$(etcdir)/rc
	rm -f $(DESTDIR)$(etcdir)/siteconfig.tcl
	rm -f $(DESTDIR)$(initrc)
	rm -f $(DESTDIR)$(modulespath)
	$(MAKE) -C init uninstall-testconfig DESTDIR=$(DESTDIR)

install: $(INSTALL_PREREQ)
	mkdir -p $(DESTDIR)$(libexecdir)
	mkdir -p $(DESTDIR)$(bindir)
	mkdir -p $(DESTDIR)$(etcdir)
	cp modulecmd.tcl $(DESTDIR)$(libexecdir)/
	chmod +x $(DESTDIR)$(libexecdir)/modulecmd.tcl
ifeq ($(compatversion),y)
	cp $(COMPAT_DIR)/modulecmd$(EXEEXT) $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
	chmod +x $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
endif
ifeq ($(libtclenvmodules),y)
	mkdir -p $(DESTDIR)$(libdir)
	cp lib/libtclenvmodules$(SHLIB_SUFFIX) $(DESTDIR)$(libdir)/libtclenvmodules$(SHLIB_SUFFIX)
	chmod +x $(DESTDIR)$(libdir)/libtclenvmodules$(SHLIB_SUFFIX)
endif
	cp contrib/envml $(DESTDIR)$(bindir)/
	chmod +x $(DESTDIR)$(bindir)/envml
	cp contrib/scripts/add.modules $(DESTDIR)$(bindir)/
	chmod +x $(DESTDIR)$(bindir)/add.modules
	cp contrib/scripts/modulecmd $(DESTDIR)$(bindir)/
	chmod +x $(DESTDIR)$(bindir)/modulecmd
	cp contrib/scripts/mkroot $(DESTDIR)$(bindir)/
	chmod +x $(DESTDIR)$(bindir)/mkroot
ifneq ($(wildcard $(DESTDIR)$(etcdir)/siteconfig.tcl),$(DESTDIR)$(etcdir)/siteconfig.tcl)
	cp siteconfig.tcl $(DESTDIR)$(etcdir)/siteconfig.tcl
endif
ifeq ($(docinstall),y)
	mkdir -p $(DESTDIR)$(docdir)
	cp COPYING.GPLv2 $(DESTDIR)$(docdir)/
	cp ChangeLog $(DESTDIR)$(docdir)/
	cp README $(DESTDIR)$(docdir)/
ifeq ($(compatversion),y)
	cp $(COMPAT_DIR)/ChangeLog $(DESTDIR)$(docdir)/ChangeLog-compat
	cp $(COMPAT_DIR)/NEWS $(DESTDIR)$(docdir)/NEWS-compat
endif
endif
ifeq ($(vimaddons),y)
	mkdir -p $(DESTDIR)$(vimdatadir)/ftdetect
	mkdir -p $(DESTDIR)$(vimdatadir)/ftplugin
	mkdir -p $(DESTDIR)$(vimdatadir)/syntax
	cp  contrib/vim/ftdetect/modulefile.vim  $(DESTDIR)$(vimdatadir)/ftdetect
	cp  contrib/vim/ftplugin/modulefile.vim  $(DESTDIR)$(vimdatadir)/ftplugin
	cp  contrib/vim/syntax/modulefile.vim    $(DESTDIR)$(vimdatadir)/syntax
endif
	$(MAKE) -C init install DESTDIR=$(DESTDIR)
ifeq ($(builddoc),y)
	$(MAKE) -C doc install DESTDIR=$(DESTDIR)
else
	@echo
	@echo "WARNING: Documentation not built nor installed"
endif
	@echo
	@echo "NOTICE: Modules installation is complete."
	@echo "        Please read the 'Configuration' section in INSTALL.txt to learn"
	@echo "        how to adapt your installation and make it fit your needs." >&2
	@echo

uninstall:
	rm -f $(DESTDIR)$(libexecdir)/modulecmd.tcl
ifeq ($(compatversion),y)
	rm -f $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
endif
ifeq ($(libtclenvmodules),y)

=== debian/changelog ===
modules (4.3.1-1) unstable; urgency=medium

  * New upstream release
  * Fixed upstream: lib-compile-error.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 24 Sep 2019 11:29:20 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

TDIR=debian/environment-modules
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

DEB_BUILD_MAINT_OPTIONS:=hardening=+all
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic
DEB_LDFLAGS_MAINT_APPEND:= -Wl,--as-needed
export  DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND

# The magic debhelper  rule
%:
	dh $@ 

override_dh_auto_clean:
	$(MAKE) clean || echo "Make clean skipped"
	rm -f stamp-h

override_dh_auto_configure:
	dh_auto_configure -- \
                --prefix=/usr/share/modules \
		--libdir=$(LIBDIR) \
		--libexecdir=$(LIBDIR) \
		--mandir=/usr/share/man \
		--etcdir=/etc/environment-modules \
		--initdir=/usr/share/modules/init \
		--with-version-path=/usr/share/modules/versions \
		--with-module-path=/usr/share/modules/modulefiles \
		--with-tcl-ver=8.6 \
		--with-tclsh=tclsh8.6 \
		--with-pager=/usr/bin/less \
		--enable-logging \
		--bindir=/usr/bin #LDFLAGS='$(LDFLAGS) -Wl,--as-needed' CFLAGS='$(CFLAGS) '

override_dh_auto_test:
	-dh_auto_test || echo "Ignoring known test failures in autoinit regexps"

override_dh_auto_install:
	dh_auto_install
	mv $(TDIR)/usr/share/modules/share/doc/* $(TDIR)/usr/share/doc/environment-modules
	rm -rf $(TDIR)/usr/share/modules/share
	rm $(TDIR)/usr/share/doc/environment-modules/COPYING.GPLv2* $(TDIR)/usr/share/doc/environment-modules/INSTALL.txt*
	rm $(TDIR)/usr/share/doc/environment-modules/ChangeLog
	cp debian/profile.sh $(TDIR)/etc/profile.d/modules.sh
	cp debian/modulespath site.exp $(TDIR)/etc/environment-modules
	dh_link /etc/environment-modules/modulespath /usr/share/modules/init/.modulespath 
	dh_link $(LIBDIR)/modulecmd.tcl /usr/lib/modulecmd.tcl
	dh_link /usr/share/modules/init/csh		/etc/csh/login.d/modules
	dh_link /usr/share/modules/init/bash_completion /usr/share/bash-completion/completions/modules

## modules 4.4.0

=== Makefile ===
--- 
+++ 
@@ -148,10 +148,16 @@
   setlibtclenvmodules := \#
 endif
 
+ifneq ($(pageropts),)
+  pagercmd := $(pager) $(pageropts)
+else
+  pagercmd := $(pager)
+endif
+
 ifeq ($(color),y)
-  setcolor := 1
-else
-  setcolor := 0
+  setcolor := auto
+else
+  setcolor := never
 endif
 
 ifeq ($(autohandling),y)
@@ -170,6 +176,18 @@
   setimplicitdefault := 1
 else
   setimplicitdefault := 0
+endif
+
+ifeq ($(extendeddefault),y)
+  setextendeddefault := 1
+else
+  setextendeddefault := 0
+endif
+
+ifeq ($(advversspec),y)
+  setadvversspec := 1
+else
+  setadvversspec := 0
 endif
 
 ifeq ($(setshellstartup),y)
@@ -192,11 +210,11 @@
 	-e 's|@initdir@|$(initdir)|g' \
 	-e 's|@etcdir@|$(etcdir)|g' \
 	-e 's|@modulefilesdir@|$(modulefilesdir)|g' \
+	-e 's|@moduleshome@|$(moduleshome)|g' \
 	-e 's|@VERSION@|$(VERSION)|g' \
 	-e 's|@TCLSHDIR@/tclsh|$(TCLSH)|g' \
 	-e 's|@TCLSH@|$(TCLSH)|g' \
-	-e 's|@pager@|$(pager)|g' \
-	-e 's|@pageropts@|$(pageropts)|g' \
+	-e 's|@pagercmd@|$(pagercmd)|g' \
 	-e 's|@verbosity@|$(verbosity)|g' \
 	-e 's|@color@|$(setcolor)|g' \
 	-e 's|@darkbgcolors@|$(darkbgcolors)|g' \
@@ -205,8 +223,11 @@
 	-e 's|@lockedconfigs@|$(lockedconfigs)|g' \
 	-e 's|@unloadmatchorder@|$(unloadmatchorder)|g' \
 	-e 's|@implicitdefault@|$(setimplicitdefault)|g' \
+	-e 's|@extendeddefault@|$(setextendeddefault)|g' \
+	-e 's|@advversspec@|$(setadvversspec)|g' \
 	-e 's|@searchmatch@|$(searchmatch)|g' \
 	-e 's|@wa277@|$(setwa277)|g' \
+	-e 's|@icase@|$(icase)|g' \
 	-e 's|@autohandling@|$(setautohandling)|g' \
 	-e 's|@availindepth@|$(setavailindepth)|g' \
 	-e 's|@silentshdbgsupport@|$(setsilentshdbgsupport)|g' \
@@ -383,14 +404,3 @@
 	@echo "WARNING: Documentation not built nor installed"
 endif
 	@echo
-	@echo "NOTICE: Modules installation is complete."
-	@echo "        Please read the 'Configuration' section in INSTALL.txt to learn"
-	@echo "        how to adapt your installation and make it fit your needs." >&2
-	@echo
-
-uninstall:
-	rm -f $(DESTDIR)$(libexecdir)/modulecmd.tcl
-ifeq ($(compatversion),y)
-	rm -f $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
-endif
-ifeq ($(libtclenvmodules),y)

=== debian/changelog ===
modules (4.4.0-1) unstable; urgency=medium

  * New upsteam release
  * Standards-Version: 4.4.1.0

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 22 Nov 2019 08:59:51 +0000

## modules 4.4.1

=== Makefile ===
--- 
+++ 
@@ -279,7 +279,15 @@
 	$(translate-in-script)
 	chmod +x $@
 
-contrib/mb: contrib/mb.in version.inc
+contrib/mb: contrib/mb.in version.inc contrib/mlprof
+	$(translate-in-script)
+	chmod +x $@
+
+contrib/mlprof: contrib/mlprof.in version.inc
+	$(translate-in-script)
+	chmod +x $@
+
+contrib/playdemo: contrib/playdemo.in version.inc
 	$(translate-in-script)
 	chmod +x $@
 
@@ -396,11 +404,3 @@
 	cp  contrib/vim/ftplugin/modulefile.vim  $(DESTDIR)$(vimdatadir)/ftplugin
 	cp  contrib/vim/syntax/modulefile.vim    $(DESTDIR)$(vimdatadir)/syntax
 endif
-	$(MAKE) -C init install DESTDIR=$(DESTDIR)
-ifeq ($(builddoc),y)
-	$(MAKE) -C doc install DESTDIR=$(DESTDIR)
-else
-	@echo
-	@echo "WARNING: Documentation not built nor installed"
-endif
-	@echo

=== init/Makefile ===
.PHONY: install install-testconfig uninstall-testconfig uninstall clean

SH_LIKE  = sh ksh bash zsh profile.sh bash_completion
CSH_LIKE = csh tcsh tcsh_completion profile.csh
OTHER    = perl.pm python.py ruby.rb lisp tcl fish cmake r.R

# example modulefiles to install
EXAMPLE_MODFILES_SRCDIR := ../contrib/modulefiles
EXAMPLE_MODFILES = dot module-git module-info modules null use.own
EXAMPLE_TESTCONFIG_MODFILES = null

# source definitions shared across the Makefiles of this project
ifneq ($(wildcard ../Makefile.inc),../Makefile.inc)
  $(error ../Makefile.inc is missing, please run '../configure')
endif
include ../Makefile.inc

# source version definitions shared across the Makefiles of this project
include ../version.inc

# generate 'module use' commands to put in modulerc from modulepath
modulerc := $(addprefix \\\nmodule use --append {,$(subst :,} ,$(modulepath)}))
# generate 'module load' commands to put in modulerc from loadedmodules
ifneq ($(loadedmodules),)
  modulerc := $(modulerc)$(addprefix \\\nmodule load ,\
    $(subst :, ,$(loadedmodules)))
endif

ifeq ($(compatversion),y)
SH_LIKE += profile-compat.sh
CSH_LIKE += profile-compat.csh
endif

ALL_SHELLS = $(SH_LIKE) $(CSH_LIKE) $(OTHER)

all: $(ALL_SHELLS) modulerc $(EXAMPLE_MODFILES_SRCDIR)/modules
ifeq ($(versioning),y)
all: $(EXAMPLE_MODFILES_SRCDIR)/version
endif
ifeq ($(setdotmodulespath),y)
  # both configuration files will be installed and in this case default init
  # scripts will use .modulespath prior to modulerc. If .modulespath sets a
  # module path then modulerc will be ignored
all: .modulespath
endif

# define init configs location
ifeq ($(initconfin),etcdir)
  modulespath := $(etcdir)/modulespath
  initrc := $(etcdir)/initrc
else
  modulespath := $(initdir)/.modulespath
  initrc := $(initdir)/modulerc
endif

# if enabled translate to keep text after markup elsewhere remove the
# entire line
ifeq ($(setmanpath),y)
  setmanpathre := s|@setmanpath@||g
else
  setmanpathre := /@setmanpath@/d
endif
ifeq ($(appendmanpath),y)
  appendmanpathre := s|@appendmanpath@||g
  prependmanpathre := /@prependmanpath@/d
else
  appendmanpathre := /@appendmanpath@/d
  prependmanpathre := s|@prependmanpath@||g
endif
ifeq ($(setbinpath),y)
  setbinpathre := s|@setbinpath@||g
else
  setbinpathre := /@setbinpath@/d
endif
ifeq ($(appendbinpath),y)
  appendbinpathre := s|@appendbinpath@||g
  prependbinpathre := /@prependbinpath@/d
else
  appendbinpathre := /@appendbinpath@/d
  prependbinpathre := s|@prependbinpath@||g
endif
ifeq ($(compatversion),y)
  compatversionre := s|@compatversion@||g
  notcompatversionre := /@notcompatversion@/d
else
  compatversionre := /@compatversion@/d
  notcompatversionre := s|@notcompatversion@||g
endif
ifeq ($(usemanpath),y)
  usemanpathre := s|@usemanpath@||g
  notusemanpathre := /@notusemanpath@/d
else
  usemanpathre := /@usemanpath@/d
  notusemanpathre := s|@notusemanpath@||g
endif
ifeq ($(silentshdbgsupport),y)
  silentshdbgsupportre := s|@silentshdbgsupport@||g
else
  silentshdbgsupportre := /@silentshdbgsupport@/d
endif
ifeq ($(quarantinesupport),y)
  quarantinesupportre := s|@quarantinesupport@||g
  notquarantinesupportre := /@notquarantinesupport@/d
else
  quarantinesupportre := /@quarantinesupport@/d
  notquarantinesupportre := s|@notquarantinesupport@||g
endif

# comment entries if feature not enabled
ifeq ($(versioning),y)
  versdir := $(baseprefix)/versions
  setversioning :=
else
  setversioning := \#
endif

# define translation rules for quarantine mechanism
ifeq ($(quarantinevars),)
setquarvarsre := /@setquarvars@/d
notsetquarvarsre := s|@notsetquarvars@||g
else
setquarvarsre := s|@setquarvars@||g
notsetquarvarsre := /@notsetquarvars@/d
define runenvvarre
$(if $(filter-out ${1},${2}),s|\(@\(.*\)RUNENV_VAR\(.*\)RUNENV_VAL\(.*\)@\)|\2MODULES_RUNENV_${1}\3${2}\4\n\1|g;)
endef
quarvarsre = -e 's|@RUN_QUARANTINE@|$(foreach vv,$(quarantinevars),$(firstword\
	$(subst =, ,$(vv))))|g;
quarvarsre += $(foreach vv,$(quarantinevars),$(call runenvvarre,$(firstword\
	$(subst =, ,$(vv))),$(subst $(firstword $(subst =, ,$(vv)))=,,$(vv))))
quarvarsre += s/@.*RUNENV_VAR.*@//;'
endif

define translate-in-script
sed -e 's|@prefix@|$(prefix)|g' \
	-e 's|@baseprefix@|$(baseprefix)|g' \
	-e 's|@libexecdir@|$(libexecdir)|g' \
	-e 's|@initdir@|$(initdir)|g' \
	-e 's|@etcdir@|$(etcdir)|g' \
	-e 's|@modulefilesdir@|$(modulefilesdir)|g' \
	-e 's|@bindir@|$(bindir)|g' \
	-e 's|@mandir@|$(mandir)|g' \
	-e '$(setmanpathre)' \
	-e '$(appendmanpathre)' \
	-e '$(prependmanpathre)' \
	-e '$(setbinpathre)' \
	-e '$(appendbinpathre)' \
	-e '$(prependbinpathre)' \
	-e '$(compatversionre)' \
	-e '$(notcompatversionre)' \
	-e '$(silentshdbgsupportre)' \
	-e '$(quarantinesupportre)' \
	-e '$(notquarantinesupportre)' \
	-e '$(usemanpathre)' \
	-e '$(notusemanpathre)' \
	-e $$'s|@modulerc@|$(modulerc)|g' \
	-e 's|@modulepath@|$(modulepath)|g' \
	-e '$(setquarvarsre)' $(quarvarsre) \
	-e '$(notsetquarvarsre)' \
	-e 's|@SHELLNAME@|$@|g' \
	-e 's|@VERSIONING@|$(setversioning)|g' \
	-e 's|@VERSION@|$(VERSION)|g' \
	-e 's|@PS@|$(PS)|g' \
	-e 's|@BASENAME@|$(BASENAME)|g' \
	-e 's|@TCLSH@|$(TCLSH)|g' $< > $@
endef

# avoid shared definitions to be rebuilt by make
../Makefile.inc ../version.inc: ;

%: %.in
	$(translate-in-script)

# workaround '\\\n' issue on Linux with Make 3.81
modulerc: modulerc.in
	$(translate-in-script)
	mv $@ ${@}.tmp
	sed -e 's|\\$$||' ${@}.tmp > $@
	rm -f ${@}.tmp

# tcsh is derivated from csh init script
tcsh: csh.in
	$(translate-in-script)

# this rule is needed for profile.sh to get matched
profile.sh: profile.sh.in
	$(translate-in-script)

# this rule is needed for profile-compat.sh to get matched
profile-compat.sh: profile-compat.sh.in
	$(translate-in-script)

$(EXAMPLE_MODFILES_SRCDIR)/modules: $(EXAMPLE_MODFILES_SRCDIR)/modules.in ../version.inc
	$(translate-in-script)

$(EXAMPLE_MODFILES_SRCDIR)/version: $(EXAMPLE_MODFILES_SRCDIR)/version.in ../version.inc
	$(translate-in-script)

# example configs for test rules
install-testconfig:
	mkdir -p $(DESTDIR)$(initdir)
	mkdir -p $(DESTDIR)$(etcdir)
	mkdir -p $(DESTDIR)$(prefix)/etc
	mkdir -p $(DESTDIR)$(modulefilesdir)
	mkdir -p $(DESTDIR)$(prefix)/test/modulefiles $(DESTDIR)$(prefix)/test/etc
	cp $(addprefix $(EXAMPLE_MODFILES_SRCDIR)/,$(EXAMPLE_TESTCONFIG_MODFILES)) $(DESTDIR)$(modulefilesdir)/

uninstall-testconfig:
	rmdir $(DESTDIR)$(prefix)/test/modulefiles $(DESTDIR)$(prefix)/test/etc $(DESTDIR)$(prefix)/test
	rm -f $(addprefix $(DESTDIR)$(modulefilesdir)/,$(EXAMPLE_TESTCONFIG_MODFILES))
	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(modulefilesdir) || true
	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(etcdir) || true
	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(initdir) || true

install: all
	mkdir -p $(DESTDIR)$(initdir)
	mkdir -p $(DESTDIR)$(initdir)/ksh-functions
	mkdir -p $(DESTDIR)$(modulefilesdir)
	cp $(ALL_SHELLS) $(DESTDIR)$(initdir)/
	cp fish_completion $(DESTDIR)$(initdir)/
	cp -r zsh-functions $(DESTDIR)$(initdir)/
	cp ksh $(DESTDIR)$(initdir)/ksh-functions/module
ifeq ($(compatversion),y)
	cp ksh $(DESTDIR)$(initdir)/ksh-functions/switchml
else
	rm -f $(DESTDIR)$(initdir)/ksh-functions/switchml
endif
	rm -f $(DESTDIR)$(modulespath) $(DESTDIR)$(initrc)
	cp -R -P modulerc $(DESTDIR)$(initrc)
ifeq ($(setdotmodulespath),y)
	cp -R -P .modulespath $(DESTDIR)$(modulespath)
endif
ifeq ($(examplemodulefiles),y)
	cp $(addprefix $(EXAMPLE_MODFILES_SRCDIR)/,$(EXAMPLE_MODFILES)) $(DESTDIR)$(modulefilesdir)/
endif
ifeq ($(versioning),y)
	mkdir -p $(DESTDIR)$(versdir)
	cp $(EXAMPLE_MODFILES_SRCDIR)/version $(DESTDIR)$(versdir)/$(VERSION)
endif

uninstall:
	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_SHELLS) fish_completion)
	rm -f $(DESTDIR)$(initdir)/ksh-functions/module
ifeq ($(compatversion),y)
	rm -f $(DESTDIR)$(initdir)/ksh-functions/switchml
endif
	rm -f $(DESTDIR)$(initdir)/zsh-functions/_module
	rm -f $(DESTDIR)$(modulespath) $(DESTDIR)$(initrc)
	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(modulefilesdir) || true
	@if [ -d $(DESTDIR)$(modulefilesdir) ]; then echo; echo "WARNING: $(DESTDIR)$(modulefilesdir) is not empty so skip removal" >&2; echo; fi
	rmdir $(DESTDIR)$(initdir)/ksh-functions
	rmdir $(DESTDIR)$(initdir)/zsh-functions
	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(initdir) || true
	@if [ -d $(DESTDIR)$(initdir) ]; then echo; echo "WARNING: $(DESTDIR)$(initdir) is not empty so skip removal" >&2; echo; fi
ifeq ($(versioning),y)
	rm -f $(DESTDIR)$(versdir)/$(VERSION)
	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(versdir) || true
	@if [ -d $(DESTDIR)$(versdir) ]; then echo; echo "WARNING: $(DESTDIR)$(versdir) is not empty so skip removal" >&2; echo; fi
endif

clean:
	rm -f $(ALL_SHELLS) modulerc .modulespath $(EXAMPLE_MODFILES_SRCDIR)/modules
ifeq ($(versioning),y)
	rm -f $(EXAMPLE_MODFILES_SRCDIR)/version
endif

=== debian/changelog ===
modules (4.4.1-1) unstable; urgency=medium

  * New upstream release
  * Specify location of pager=/usr/bin/less

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 09 Jan 2020 13:02:22 +0000

=== debian/control ===
Source: modules
Section: devel
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Standards-Version: 4.4.1.0
Homepage: http://modules.sourceforge.net/
Vcs-Browser: https://salsa.debian.org:/mckinstry/modules.git
Vcs-Git: https://salsa.debian.org:/mckinstry/modules.git
Build-Depends: tcl8.6-dev | tcl-dev, 
  debhelper-compat (= 12), 
  dejagnu, 
  tclx8.4-dev,
  less,
  procps

Package: environment-modules
Architecture: any
Depends: tcl8.6, ${misc:Depends}, ${shlibs:Depends},
 less, procps
Conflicts: lmod
Description: Modular system for handling environment variables
 The Modules package provides for the dynamic modification of a user's
 environment via modulefiles.  Each modulefile contains the information
 needed to configure the shell for an application. Once the Modules
 package is initialized, the environment can be modified dynamically
 on a per-module basis using the module command which interprets
 modulefiles. Typically modulefiles instruct the module command to alter or
 set shell environment variables such as PATH, MANPATH, etc. modulefiles
 may be shared by many users on a system and users may have their own
 collection to supplement or replace the shared modulefiles.  The modules
 environment is common on SGI/Crays and many workstation farms.

=== debian/rules ===
--- 
+++ 
@@ -31,8 +31,8 @@
 		--with-module-path=/usr/share/modules/modulefiles \
 		--with-tcl-ver=8.6 \
 		--with-tclsh=tclsh8.6 \
+		--enable-logging \
 		--with-pager=/usr/bin/less \
-		--enable-logging \
 		--bindir=/usr/bin #LDFLAGS='$(LDFLAGS) -Wl,--as-needed' CFLAGS='$(CFLAGS) '
 
 override_dh_auto_test:

## modules 4.5.0

=== Makefile ===
--- 
+++ 
@@ -2,14 +2,18 @@
 	install-testsiteconfig-1 install-testmodulerc install-testmodulerc-1 \
 	install-testinitrc install-testetcrc install-testmodspath \
 	install-testmodspath-empty uninstall-testconfig uninstall dist dist-tar \
-	dist-gzip dist-bzip2 srpm clean distclean test testinstall testsyntax
+	dist-gzip dist-bzip2 dist-win srpm rpm clean distclean test testinstall \
+	testsyntax
+
+# download command and its options
+WGET := wget --timeout=5 --tries=2
 
 # definitions for code coverage
 NAGELFAR_DLSRC1 := http://downloads.sourceforge.net/nagelfar/
-NAGELFAR_DLSRC2 := https://ftp.openbsd.org/pub/OpenBSD/distfiles/
-NAGELFAR_RELEASE := nagelfar125
+NAGELFAR_DLSRC2 := https://osdn.net/projects/sfnet_nagelfar/downloads/Rel_131/
+NAGELFAR_RELEASE := nagelfar131
 NAGELFAR_DIST := $(NAGELFAR_RELEASE).tar.gz
-NAGELFAR_DISTSUM := 707e3c305437dce1f14103f0bd058fc9
+NAGELFAR_DISTSUM := fbf79ab1a1d85349600f2502a3353bf4
 NAGELFAR := $(NAGELFAR_RELEASE)/nagelfar.tcl
 
 # definition for old Tcl interpreter for coverage testing
@@ -23,8 +27,8 @@
 MODULECMDTEST := modulecmd-test.tcl
 
 # definitions for enhanced diff tool (to review test results)
-ICDIFF_DLSRC := https://raw.githubusercontent.com/jeffkaufman/icdiff/release-1.9.2/
-ICDIFF_CHECKSUM := 2bf052d9dfb0a46af581fc390c47774a
+ICDIFF_DLSRC := https://raw.githubusercontent.com/jeffkaufman/icdiff/release-1.9.5/
+ICDIFF_CHECKSUM := fd5825ede4c2853ba1747a8931b077c1
 
 # compatibility version-related files
 COMPAT_DIR := compat
@@ -35,8 +39,8 @@
 endif
 include Makefile.inc
 
-INSTALL_PREREQ := modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
-	contrib/scripts/modulecmd
+INSTALL_PREREQ := modulecmd.tcl ChangeLog README script/add.modules \
+	script/createmodule.py script/modulecmd
 TEST_PREREQ := $(MODULECMDTEST)
 
 ifeq ($(compatversion),y)
@@ -63,10 +67,17 @@
 TEST_PREREQ += tclsh83
 endif
 
+# define rule prereq when target need to be rebuilt when git repository change
+ifeq ($(wildcard .git),.git)
+GIT_REFRESH_PREREQ := .git/index
+else
+GIT_REFRESH_PREREQ := 
+endif
+
 all: initdir $(INSTALL_PREREQ)
 
 # skip doc build if no sphinx-build
-ifeq ($(builddoc),y)
+ifneq ($(builddoc),n)
 all: pkgdoc
 endif
 
@@ -95,6 +106,37 @@
 MODULES_BUILD := +$(GIT_CURRENT_BRANCH)$(subst $(GIT_CURRENT_TAG),,$(GIT_CURRENT_DESC))
 endif
 
+else
+# load raw version information
+include version.inc.in
+
+# build short date from full date found in raw data
+ifeq ($(MODULES_BUILD_FDATE),$$Format:%ci$$)
+MODULES_BUILD_DATE := $(shell date '+%Y-%m-%d')
+else
+MODULES_BUILD_DATE := $(firstword $(MODULES_BUILD_FDATE))
+endif
+
+# set a recognizable build number if one found in version.inc.in is raw data
+ifeq ($(MODULES_BUILD_HASH),$$Format:%h$$)
+MODULES_BUILD := +XX-gffffffff
+# or compute it from these information as if working from git repository
+else
+comma := ,
+MODULES_BUILD_REFS := $(subst $(comma),,$(MODULES_BUILD_REFS))
+
+ifeq ($(filter v$(MODULES_RELEASE),$(MODULES_BUILD_REFS)),v$(MODULES_RELEASE))
+MODULES_BUILD :=
+else ifeq ($(filter master,$(MODULES_BUILD_REFS)),master)
+MODULES_BUILD := +XX-g$(MODULES_BUILD_HASH)
+else ifeq ($(MODULES_BUILD_REFS),%D)
+MODULES_BUILD := +XX-g$(MODULES_BUILD_HASH)
+else
+MODULES_BUILD := +$(lastword $(MODULES_BUILD_REFS))-XX-g$(MODULES_BUILD_HASH)
+endif
+endif
+endif
+
 # determine RPM release
 # use last release if we currently sat on tag, append build number to it elsewhere
 MODULES_LAST_RPM_VERSREL := $(shell sed -n '/^%changelog/ {n;s/^\*.* - //p;q;}' \
@@ -102,14 +144,6 @@
 MODULES_LAST_RPM_RELEASE := $(lastword $(subst -, ,$(MODULES_LAST_RPM_VERSREL)))
 MODULES_RPM_RELEASE := $(MODULES_LAST_RPM_RELEASE)$(subst +,.,$(subst -,.,$(MODULES_BUILD)))
 
-else
-# source version definitions shared across the Makefiles of this project
-ifneq ($(wildcard version.inc),version.inc)
-  $(error version.inc is missing)
-endif
-include version.inc
-endif
-
 # define init configs location
 ifeq ($(initconfin),etcdir)
   modulespath := $(etcdir)/modulespath
@@ -188,6 +222,12 @@
   setadvversspec := 1
 else
   setadvversspec := 0
+endif
+
+ifeq ($(ml),y)
+  setml := 1
+else
+  setml := 0
 endif
 
 ifeq ($(setshellstartup),y)
@@ -214,6 +254,7 @@
 	-e 's|@VERSION@|$(VERSION)|g' \
 	-e 's|@TCLSHDIR@/tclsh|$(TCLSH)|g' \
 	-e 's|@TCLSH@|$(TCLSH)|g' \
+	-e 's|@PYTHON@|$(PYTHON)|g' \
 	-e 's|@pagercmd@|$(pagercmd)|g' \
 	-e 's|@verbosity@|$(verbosity)|g' \
 	-e 's|@color@|$(setcolor)|g' \
@@ -231,6 +272,7 @@
 	-e 's|@autohandling@|$(setautohandling)|g' \
 	-e 's|@availindepth@|$(setavailindepth)|g' \
 	-e 's|@silentshdbgsupport@|$(setsilentshdbgsupport)|g' \
+	-e 's|@ml@|$(setml)|g' \
 	-e 's|@setshellstartup@|$(setsetshellstartup)|g' \
 	-e 's|@quarantinesupport@|$(setquarantinesupport)|g' \
 	-e 's|@notquarantinesupport@|$(setnotquarantinesupport)|g' \
@@ -244,58 +286,52 @@
 	-e 's|@MODULES_BUILD_DATE@|$(MODULES_BUILD_DATE)|g' $< > $@
 endef
 
-ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
-# rebuild if git repository changed
-version.inc: version.inc.in .git/index
-	$(translate-in-script)
-
-contrib/rpm/environment-modules.spec: contrib/rpm/environment-modules.spec.in .git/index
-	$(translate-in-script)
-
-else
-# avoid shared definitions to be rebuilt by make
-version.inc: ;
-
-# do not rebuild spec file if not in git repository
-contrib/rpm/environment-modules.spec: ;
-endif
-
 DIST_PREFIX := modules-$(MODULES_RELEASE)$(MODULES_BUILD)
+DIST_WIN_PREFIX := $(DIST_PREFIX)-win
 
 # avoid shared definitions to be rebuilt by make
 Makefile.inc: ;
 
+version.inc: version.inc.in $(GIT_REFRESH_PREREQ)
+	$(translate-in-script)
+
+# source version definitions shared across the Makefiles of this project
+include version.inc
+
+contrib/rpm/environment-modules.spec: contrib/rpm/environment-modules.spec.in $(GIT_REFRESH_PREREQ)
+	$(translate-in-script)
+
 modulecmd.tcl: modulecmd.tcl.in version.inc
 	$(translate-in-script)
 	chmod +x $@
 
+# generate an empty changelog file if not working from git repository
+ifeq ($(wildcard .git),.git)
+ChangeLog: script/gitlog2changelog.py
+	script/gitlog2changelog.py
+else
 ChangeLog:
-	contrib/gitlog2changelog.py
+	echo "Please refer to the NEWS document to learn about main changes" >$@
+endif
 
 README:
 	sed -e '/^\[\!\[.*\].*/d' $@.md > $@
 
-contrib/mtreview: contrib/mtreview.in version.inc
+script/add.modules: script/add.modules.in
 	$(translate-in-script)
 	chmod +x $@
 
-contrib/mb: contrib/mb.in version.inc contrib/mlprof
+script/createmodule.py: script/createmodule.py.in
 	$(translate-in-script)
 	chmod +x $@
 
-contrib/mlprof: contrib/mlprof.in version.inc
+script/gitlog2changelog.py: script/gitlog2changelog.py.in
 	$(translate-in-script)
 	chmod +x $@
 
-contrib/playdemo: contrib/playdemo.in version.inc
+script/modulecmd: script/modulecmd.in
 	$(translate-in-script)
 	chmod +x $@
-
-contrib/scripts/add.modules: contrib/scripts/add.modules.in
-	$(translate-in-script)
-
-contrib/scripts/modulecmd: contrib/scripts/modulecmd.in
-	$(translate-in-script)
 
 # compatibility version-related rules
 $(COMPAT_DIR)/modulecmd$(EXEEXT) $(COMPAT_DIR)/ChangeLog:
@@ -375,32 +411,6 @@
 	cp lib/libtclenvmodules$(SHLIB_SUFFIX) $(DESTDIR)$(libdir)/libtclenvmodules$(SHLIB_SUFFIX)
 	chmod +x $(DESTDIR)$(libdir)/libtclenvmodules$(SHLIB_SUFFIX)
 endif
-	cp contrib/envml $(DESTDIR)$(bindir)/
+	cp script/envml $(DESTDIR)$(bindir)/
 	chmod +x $(DESTDIR)$(bindir)/envml
-	cp contrib/scripts/add.modules $(DESTDIR)$(bindir)/
-	chmod +x $(DESTDIR)$(bindir)/add.modules
-	cp contrib/scripts/modulecmd $(DESTDIR)$(bindir)/
-	chmod +x $(DESTDIR)$(bindir)/modulecmd
-	cp contrib/scripts/mkroot $(DESTDIR)$(bindir)/
-	chmod +x $(DESTDIR)$(bindir)/mkroot
-ifneq ($(wildcard $(DESTDIR)$(etcdir)/siteconfig.tcl),$(DESTDIR)$(etcdir)/siteconfig.tcl)
-	cp siteconfig.tcl $(DESTDIR)$(etcdir)/siteconfig.tcl
-endif
-ifeq ($(docinstall),y)
-	mkdir -p $(DESTDIR)$(docdir)
-	cp COPYING.GPLv2 $(DESTDIR)$(docdir)/
-	cp ChangeLog $(DESTDIR)$(docdir)/
-	cp README $(DESTDIR)$(docdir)/
-ifeq ($(compatversion),y)
-	cp $(COMPAT_DIR)/ChangeLog $(DESTDIR)$(docdir)/ChangeLog-compat
-	cp $(COMPAT_DIR)/NEWS $(DESTDIR)$(docdir)/NEWS-compat
-endif
-endif
-ifeq ($(vimaddons),y)
-	mkdir -p $(DESTDIR)$(vimdatadir)/ftdetect
-	mkdir -p $(DESTDIR)$(vimdatadir)/ftplugin
-	mkdir -p $(DESTDIR)$(vimdatadir)/syntax
-	cp  contrib/vim/ftdetect/modulefile.vim  $(DESTDIR)$(vimdatadir)/ftdetect
-	cp  contrib/vim/ftplugin/modulefile.vim  $(DESTDIR)$(vimdatadir)/ftplugin
-	cp  contrib/vim/syntax/modulefile.vim    $(DESTDIR)$(vimdatadir)/syntax
-endif
+	cp script/add.modules $(DESTDIR)$(bindir)/

=== debian/changelog ===
modules (4.5.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.5.0
  * Depend on python3 as python3 createmodules script included

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 14 Apr 2020 14:56:07 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Standards-Version: 4.4.1.0
+Standards-Version: 4.5.0
 Homepage: http://modules.sourceforge.net/
 Vcs-Browser: https://salsa.debian.org:/mckinstry/modules.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/modules.git
@@ -16,7 +16,7 @@
 Package: environment-modules
 Architecture: any
 Depends: tcl8.6, ${misc:Depends}, ${shlibs:Depends},
- less, procps
+ less, procps, python3
 Conflicts: lmod
 Description: Modular system for handling environment variables
  The Modules package provides for the dynamic modification of a user's

## modules 4.5.1

=== debian/changelog ===
modules (4.5.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 06 Jun 2020 17:47:59 +0100

## modules 4.5.2

=== debian/changelog ===
modules (4.5.2-1) unstable; urgency=medium

  * New upstream release
  * Move to debhelper level 13
  * configure.patch: Add back previously-ignored parameters

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 04 Aug 2020 09:38:06 +0100

## modules 4.6.0

=== Makefile ===
--- 
+++ 
@@ -2,15 +2,14 @@
 	install-testsiteconfig-1 install-testmodulerc install-testmodulerc-1 \
 	install-testinitrc install-testetcrc install-testmodspath \
 	install-testmodspath-empty uninstall-testconfig uninstall dist dist-tar \
-	dist-gzip dist-bzip2 dist-win srpm rpm clean distclean test testinstall \
-	testsyntax
+	dist-gzip dist-bzip2 dist-win srpm rpm clean distclean test-deps test \
+	testinstall testsyntax
 
 # download command and its options
-WGET := wget --timeout=5 --tries=2
+WGET := wget --retry-connrefused --waitretry=20 --timeout=20 --tries=3
 
 # definitions for code coverage
 NAGELFAR_DLSRC1 := http://downloads.sourceforge.net/nagelfar/
-NAGELFAR_DLSRC2 := https://osdn.net/projects/sfnet_nagelfar/downloads/Rel_131/
 NAGELFAR_RELEASE := nagelfar131
 NAGELFAR_DIST := $(NAGELFAR_RELEASE).tar.gz
 NAGELFAR_DISTSUM := fbf79ab1a1d85349600f2502a3353bf4
@@ -54,7 +53,12 @@
 INSTALL_PREREQ += lib/libtclenvmodules$(SHLIB_SUFFIX)
 TEST_PREREQ += lib/libtclenvmodules$(SHLIB_SUFFIX)
 ifeq ($(COVERAGE),y)
-TEST_PREREQ += lib/libtestutil-closedir$(SHLIB_SUFFIX)
+TEST_PREREQ += lib/libtestutil-closedir$(SHLIB_SUFFIX) \
+	lib/libtestutil-getpwuid$(SHLIB_SUFFIX) \
+	lib/libtestutil-getgroups$(SHLIB_SUFFIX) \
+	lib/libtestutil-0getgroups$(SHLIB_SUFFIX) \
+	lib/libtestutil-dupgetgroups$(SHLIB_SUFFIX) \
+	lib/libtestutil-getgrgid$(SHLIB_SUFFIX)
 endif
 endif
 
@@ -182,6 +186,16 @@
   setlibtclenvmodules := \#
 endif
 
+ifeq ($(multilibsupport),y)
+  setmultilibsupport :=
+  setnotmultilibsupport := \#
+  sedexprlibdir := -e 's|@libdir64@|$(libdir64)|g' -e 's|@libdir32@|$(libdir32)|g'
+else
+  setmultilibsupport := \#
+  setnotmultilibsupport :=
+  sedexprlibdir := -e 's|@libdir@|$(libdir)|g'
+endif
+
 ifneq ($(pageropts),)
   pagercmd := $(pager) $(pageropts)
 else
@@ -245,7 +259,7 @@
 define translate-in-script
 sed -e 's|@prefix@|$(prefix)|g' \
 	-e 's|@baseprefix@|$(baseprefix)|g' \
-	-e 's|@libdir@|$(libdir)|g' \
+	$(sedexprlibdir) \
 	-e 's|@libexecdir@|$(libexecdir)|g' \
 	-e 's|@initdir@|$(initdir)|g' \
 	-e 's|@etcdir@|$(etcdir)|g' \
@@ -269,6 +283,7 @@
 	-e 's|@searchmatch@|$(searchmatch)|g' \
 	-e 's|@wa277@|$(setwa277)|g' \
 	-e 's|@icase@|$(icase)|g' \
+	-e 's|@nearlyforbiddendays@|$(nearlyforbiddendays)|g' \
 	-e 's|@autohandling@|$(setautohandling)|g' \
 	-e 's|@availindepth@|$(setavailindepth)|g' \
 	-e 's|@silentshdbgsupport@|$(setsilentshdbgsupport)|g' \
@@ -278,6 +293,8 @@
 	-e 's|@notquarantinesupport@|$(setnotquarantinesupport)|g' \
 	-e 's|@libtclenvmodules@|$(setlibtclenvmodules)|g' \
 	-e 's|@SHLIB_SUFFIX@|$(SHLIB_SUFFIX)|g' \
+	-e 's|@multilibsupport@|$(setmultilibsupport)|g' \
+	-e 's|@notmultilibsupport@|$(setnotmultilibsupport)|g' \
 	-e 's|@VERSIONING@|$(setversioning)|g' \
 	-e 's|@NOTVERSIONING@|$(setnotversioning)|g' \
 	-e 's|@MODULES_RELEASE@|$(MODULES_RELEASE)|g' \
@@ -315,7 +332,7 @@
 endif
 
 README:
-	sed -e '/^\[\!\[.*\].*/d' $@.md > $@
+	sed -e '1,9d' $@.md > $@
 
 script/add.modules: script/add.modules.in
 	$(translate-in-script)
@@ -344,6 +361,21 @@
 lib/libtestutil-closedir$(SHLIB_SUFFIX):
 	$(MAKE) -C lib $(@F)
 
+lib/libtestutil-getpwuid$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
+lib/libtestutil-getgroups$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
+lib/libtestutil-0getgroups$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
+lib/libtestutil-dupgetgroups$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
+lib/libtestutil-getgrgid$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
 # example configs for test rules
 testsuite/example/.modulespath: testsuite/example/.modulespath.in
 	$(translate-in-script)
@@ -389,28 +421,3 @@
 	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(modulespath)
 
-uninstall-testconfig:
-	rm -f $(DESTDIR)$(etcdir)/rc
-	rm -f $(DESTDIR)$(etcdir)/siteconfig.tcl
-	rm -f $(DESTDIR)$(initrc)
-	rm -f $(DESTDIR)$(modulespath)
-	$(MAKE) -C init uninstall-testconfig DESTDIR=$(DESTDIR)
-
-install: $(INSTALL_PREREQ)
-	mkdir -p $(DESTDIR)$(libexecdir)
-	mkdir -p $(DESTDIR)$(bindir)
-	mkdir -p $(DESTDIR)$(etcdir)
-	cp modulecmd.tcl $(DESTDIR)$(libexecdir)/
-	chmod +x $(DESTDIR)$(libexecdir)/modulecmd.tcl
-ifeq ($(compatversion),y)
-	cp $(COMPAT_DIR)/modulecmd$(EXEEXT) $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
-	chmod +x $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
-endif
-ifeq ($(libtclenvmodules),y)
-	mkdir -p $(DESTDIR)$(libdir)
-	cp lib/libtclenvmodules$(SHLIB_SUFFIX) $(DESTDIR)$(libdir)/libtclenvmodules$(SHLIB_SUFFIX)
-	chmod +x $(DESTDIR)$(libdir)/libtclenvmodules$(SHLIB_SUFFIX)
-endif
-	cp script/envml $(DESTDIR)$(bindir)/
-	chmod +x $(DESTDIR)$(bindir)/envml
-	cp script/add.modules $(DESTDIR)$(bindir)/

=== debian/changelog ===
modules (4.6.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 20 Sep 2020 09:32:34 +0100

modules (4.5.3-1) unstable; urgency=medium

  * New upstream release
  * Add d/gbp.conf to match new DEP-14 git branch names

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Sep 2020 08:36:50 +0100

## modules 4.6.1

=== Makefile ===
--- 
+++ 
@@ -58,7 +58,9 @@
 	lib/libtestutil-getgroups$(SHLIB_SUFFIX) \
 	lib/libtestutil-0getgroups$(SHLIB_SUFFIX) \
 	lib/libtestutil-dupgetgroups$(SHLIB_SUFFIX) \
-	lib/libtestutil-getgrgid$(SHLIB_SUFFIX)
+	lib/libtestutil-getgrgid$(SHLIB_SUFFIX) \
+	lib/libtestutil-time$(SHLIB_SUFFIX) \
+	lib/libtestutil-mktime$(SHLIB_SUFFIX)
 endif
 endif
 
@@ -376,6 +378,12 @@
 lib/libtestutil-getgrgid$(SHLIB_SUFFIX):
 	$(MAKE) -C lib $(@F)
 
+lib/libtestutil-time$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
+lib/libtestutil-mktime$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
 # example configs for test rules
 testsuite/example/.modulespath: testsuite/example/.modulespath.in
 	$(translate-in-script)
@@ -415,9 +423,3 @@
 
 install-testmodspath: testsuite/example/.modulespath
 	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
-	cp $^ $(DESTDIR)$(modulespath)
-
-install-testmodspath-empty: testsuite/example/.modulespath-empty
-	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
-	cp $^ $(DESTDIR)$(modulespath)
-

=== init/Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
-.PHONY: install install-testconfig uninstall-testconfig uninstall clean
+.PHONY: dist-win install install-testconfig uninstall-testconfig uninstall \
+	clean
 
 SH_LIKE  = sh ksh bash zsh profile.sh bash_completion
 CSH_LIKE = csh tcsh tcsh_completion profile.csh
@@ -7,6 +8,7 @@
 # example modulefiles to install
 EXAMPLE_MODFILES_SRCDIR := ../contrib/modulefiles
 EXAMPLE_MODFILES = dot module-git module-info modules null use.own
+EXAMPLE_WIN_MODFILES = module-git module-info null
 EXAMPLE_TESTCONFIG_MODFILES = null
 
 # source definitions shared across the Makefiles of this project
@@ -33,7 +35,7 @@
 
 ALL_SHELLS = $(SH_LIKE) $(CSH_LIKE) $(OTHER)
 
-all: $(ALL_SHELLS) modulerc $(EXAMPLE_MODFILES_SRCDIR)/modules
+all: $(ALL_SHELLS) modulerc zsh-functions/_module $(EXAMPLE_MODFILES_SRCDIR)/modules
 ifeq ($(versioning),y)
 all: $(EXAMPLE_MODFILES_SRCDIR)/version
 endif
@@ -160,6 +162,7 @@
 	-e 's|@SHELLNAME@|$@|g' \
 	-e 's|@VERSIONING@|$(setversioning)|g' \
 	-e 's|@VERSION@|$(VERSION)|g' \
+	-e 's|@SED_ERE@|$(SED_ERE)|g' \
 	-e 's|@PS@|$(PS)|g' \
 	-e 's|@BASENAME@|$(BASENAME)|g' \
 	-e 's|@TCLSH@|$(TCLSH)|g' $< > $@
@@ -195,6 +198,12 @@
 
 $(EXAMPLE_MODFILES_SRCDIR)/version: $(EXAMPLE_MODFILES_SRCDIR)/version.in ../version.inc
 	$(translate-in-script)
+
+dist-win:
+	mkdir $(DIST_WIN_PREFIX)/init
+	cp cmd.cmd $(DIST_WIN_PREFIX)/init/
+	mkdir $(DIST_WIN_PREFIX)/modulefiles
+	cp $(addprefix $(EXAMPLE_MODFILES_SRCDIR)/,$(EXAMPLE_WIN_MODFILES)) $(DIST_WIN_PREFIX)/modulefiles/
 
 # example configs for test rules
 install-testconfig:
@@ -215,11 +224,16 @@
 install: all
 	mkdir -p $(DESTDIR)$(initdir)
 	mkdir -p $(DESTDIR)$(initdir)/ksh-functions
+	mkdir -p $(DESTDIR)$(initdir)/zsh-functions
 	mkdir -p $(DESTDIR)$(modulefilesdir)
 	cp $(ALL_SHELLS) $(DESTDIR)$(initdir)/
+ifeq ($(windowssupport),y)
+	cp cmd.cmd $(DESTDIR)$(initdir)/
+endif
 	cp fish_completion $(DESTDIR)$(initdir)/
-	cp -r zsh-functions $(DESTDIR)$(initdir)/
+	cp zsh-functions/_module $(DESTDIR)$(initdir)/zsh-functions/
 	cp ksh $(DESTDIR)$(initdir)/ksh-functions/module
+	cp ksh $(DESTDIR)$(initdir)/ksh-functions/ml
 ifeq ($(compatversion),y)
 	cp ksh $(DESTDIR)$(initdir)/ksh-functions/switchml
 else
@@ -240,7 +254,11 @@
 
 uninstall:
 	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_SHELLS) fish_completion)
+ifeq ($(windowssupport),y)
+	rm -f $(DESTDIR)$(initdir)/cmd.cmd
+endif
 	rm -f $(DESTDIR)$(initdir)/ksh-functions/module
+	rm -f $(DESTDIR)$(initdir)/ksh-functions/ml
 ifeq ($(compatversion),y)
 	rm -f $(DESTDIR)$(initdir)/ksh-functions/switchml
 endif
@@ -259,7 +277,7 @@
 endif
 
 clean:
-	rm -f $(ALL_SHELLS) modulerc .modulespath $(EXAMPLE_MODFILES_SRCDIR)/modules
+	rm -f $(ALL_SHELLS) modulerc zsh-functions/_module .modulespath $(EXAMPLE_MODFILES_SRCDIR)/modules
 ifeq ($(versioning),y)
 	rm -f $(EXAMPLE_MODFILES_SRCDIR)/version
 endif

=== debian/changelog ===
modules (4.6.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 15 Nov 2020 15:50:36 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Vcs-Browser: https://salsa.debian.org:/mckinstry/modules.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/modules.git
 Build-Depends: tcl8.6-dev | tcl-dev, 
-  debhelper-compat (= 12), 
+  debhelper-compat (= 13), 
   dejagnu, 
   tclx8.4-dev,
   less,
